=== added file 'src/com/goldencode/p2j/ui/client/gui/CalendarGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/CalendarGuiImpl.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/gui/CalendarGuiImpl.java	2020-02-25 12:55:07 +0000
@@ -0,0 +1,2800 @@
+/*
+** Module   : CalendarGuiImpl.java
+** Abstract : CalendarGuiImpl implements the calendar widget.
+**
+** Copyright (c) 2020, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- --------------------------------Description-----------------------------------
+** 001 SBI 20200114 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+
+package com.goldencode.p2j.ui.client.gui;
+
+import java.awt.event.MouseEvent;
+import java.text.*;
+import java.time.*;
+import java.time.chrono.*;
+import java.time.format.*;
+import java.time.temporal.ChronoField;
+import java.util.*;
+import java.util.function.*;
+
+import com.goldencode.p2j.ui.*;
+import com.goldencode.p2j.ui.CalendarConfig.*;
+import com.goldencode.p2j.ui.chui.ThinClient;
+import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.event.*;
+import com.goldencode.p2j.ui.client.event.listener.*;
+import com.goldencode.p2j.ui.client.gui.GuiFontResolver.*;
+import com.goldencode.p2j.ui.client.gui.driver.*;
+import com.goldencode.p2j.ui.client.gui.driver.LightweightTextWidget.*;
+import com.goldencode.p2j.ui.client.gui.theme.*;
+import com.goldencode.p2j.ui.client.gui.theme.Theme.TextLookAndFeel.*;
+import com.goldencode.p2j.ui.client.gui.theme.Theme.*;
+import com.goldencode.p2j.ui.client.layout.*;
+import com.goldencode.p2j.ui.client.layout.StackLayout.*;
+import com.goldencode.p2j.ui.client.widget.*;
+import com.goldencode.p2j.util.*;
+import com.goldencode.util.*;
+
+/**
+ * Implements the calendar widget.
+ */
+public class CalendarGuiImpl
+extends BorderedPanelGuiImpl
+implements WidgetWithConfig<CalendarConfig>,
+           FocusListener,
+           DataContainer
+{
+   /** The standard button's size */ 
+   private static final int BUTTON_SIZE = 28;
+   
+   /** The standard margins around a given button */
+   private static final int BUTTON_MARGIN = 2;
+   
+   /** The standard margin between controls in a row */
+   private static final int HORIZONTAL_CELL_MARGIN = 4;
+   
+   /** The standard margin between rows */
+   private static final int VERTICAL_ROW_MARGIN = 2;
+   
+   /** The displayed rows */
+   private static final int ROWS_NUMBER = 9;
+   
+   /** The displayed columns */
+   private static final int COLUMNS_NUMBER = 7;
+   
+   /** Holds its settings */
+   private CalendarConfig config;
+   
+   /** Screen driver */
+   private GuiDriver gd;
+   
+   /** Output manager */
+   private GuiOutputManager screen;
+   
+   /** GUI widgets factory */
+   private GuiWidgetFactory widgetsFactory;
+   
+   /** Coordinate converter */
+   private CoordinatesConversion cc;
+
+   /** Body color resolver */
+   private GuiColorResolver bodyColorResolver;
+   
+   /** Title color resolver for calendar header */
+   private GuiColorResolver titleColorResolver;
+   
+   /** Trailing days and selected day color resolver */
+   private GuiColorResolver trailingColorResolver;
+   
+   /** Font resolver */
+   private GuiFontResolver fontResolver;
+   
+   /** The system locale */
+   private Locale locale;
+   
+   /** The system calendar */
+   private Chronology chrono;
+   
+   /** The date time formatter */
+   private DateTimeFormatter dateTimeFormatter;
+   
+   /** The current date and time pattern */
+   private String dateTimePattern;
+   
+   /** The array of date and time fields displayed by the current pattern */
+   private FieldPosition[] fieldPositions;
+   
+   /** The displayed date and time value without a time-zone in the ISO-8601 calendar system */
+   private LocalDateTime displayedDateTime;
+   
+   /** The date/time content is implemented as a scrollable widget. */
+   private DateTimeContent dateTimeContent;
+   
+   /** The date/time content view */
+   private Viewport<GuiOutputManager> viewport;
+   
+   /** The button's panel */
+   private BorderedPanelGuiImpl buttonsPanel;
+   
+   /** The popup button */
+   private ButtonGuiImpl popupButton;
+   
+   /** The up button */
+   private ButtonGuiImpl upButton;
+   
+   /** The down button */
+   private ButtonGuiImpl downButton;
+   
+   /** The toggle button */
+   private ToggleBoxGuiImpl toggleButton;
+   
+   /** This flag has been set once, required for this widget initialization */
+   private boolean init;
+   
+   /** The flag indicating that the calendar popup is active or not */
+   private boolean popupIsActive;
+   
+   
+   /**
+    * Creates the calendar widget.
+    * 
+    * @param    id
+    *           The given widget's id.
+    * @param    cfg
+    *           The widget's configuration
+    */
+   public CalendarGuiImpl(WidgetId id, CalendarConfig cfg)
+   {
+      super(new StackLayout<GuiOutputManager>(Direction.HORIZONTAL), new LineBorderGuiImpl());
+      setId(id);
+      config = cfg;
+   }
+   
+   /**
+    * Defines a factory method to create a button.
+    * 
+    * @param    name
+    *           The given name
+    * @param    width
+    *           The given widget's width
+    * @param    height
+    *           The given widget's height
+    * @param    imageSetter
+    *           Sets the target images for a new created button.
+    * 
+    * @return   The target button implementation
+    */
+   public ButtonGuiImpl createButton(String name,
+                                     int width,
+                                     int height,
+                                     Consumer<ButtonGuiImpl> imageSetter)
+   {
+      WidgetId wid = WidgetId.nextID();
+      
+      ButtonGuiImpl button = widgetsFactory.createButton(wid, null, name + wid.asInt());
+      
+      button.config().widthPixels  = width;
+      button.config().heightPixels = height;
+      button.config().widthChars  = cc.widthFromNative(width);
+      button.config().heightChars = cc.heightFromNative(height);
+      button.config().enabled = true;
+      button.config().visible = true;
+      button.config().fixedWidth = true;
+      button.config().fixedHeight = true;
+      button.config().x = 0;
+      button.config().y = 0;
+      
+      imageSetter.accept(button);
+      
+      button.initialize(wid, null);
+      
+      return button;
+   }
+   
+   /**
+    * Calculates the size of this widget in character units.
+    * 
+    * @return   The size of this widget in character units
+    */
+   @Override
+   public Dimension dimension()
+   {
+      double width = width();
+      double height = height();
+      
+      return new Dimension(width, height);
+   }
+
+   /**
+    * Returns the height of this widget.
+    * 
+    * @return   The widget's height in character units.
+    */
+   @Override
+   public double height()
+   {
+      return config.heightChars;
+   }
+
+   /**
+    * Returns the minimum size of this widget.
+    * 
+    * @return   The minimum size of this widget
+    */
+   @Override
+   public Dimension minimumSize()
+   {
+      return dimension();
+   }
+
+   /**
+    * Returns the width of this widget.
+    * 
+    * @return   The widget's width in character units.
+    */
+   @Override
+   public double width()
+   {
+      return config.widthChars;
+   }
+
+   /**
+    * Returns the widget's configuration.
+    * 
+    * @return   The calendar configuration
+    */
+   @Override
+   public CalendarConfig config()
+   {
+      return config;
+   }
+   
+   /**
+    * Notifies this widget that its settings are changed.
+    * 
+    * @param    beforeUpdate
+    *           The old configuration
+    */
+   @Override
+   public void afterConfigUpdate(CalendarConfig beforeUpdate)
+   {
+      super.afterConfigUpdateBase(beforeUpdate);
+      
+      boolean repaint = false;
+      boolean updateSize = false;
+      
+      if (beforeUpdate.formatStyle != config.formatStyle || 
+          !StringHelper.equal(config.customFormat, beforeUpdate.customFormat) ||
+          !StringHelper.equal(config.dateTimeValue, beforeUpdate.dateTimeValue))
+      {
+         LocalDateTime modifiedDateTime;
+         
+         if (config.dateTimeValue != null)
+         {
+            modifiedDateTime = LocalDateTime.parse(config.dateTimeValue);
+         }
+         else
+         {
+            modifiedDateTime = displayedDateTime;
+         }
+
+         updateDateTimePattern(config.formatStyle, config.customFormat, modifiedDateTime);
+         updateSize = true;
+      }
+      
+      if (init || beforeUpdate.font != config.font ||
+          !Utils.equals(beforeUpdate.fontName, config.fontName) ||
+           beforeUpdate.fontSize != config.fontSize)
+      {
+         FontCache fntCache = fontResolver.font();
+         
+         fontResolver.updateFontCache(config.font, fntCache.font);
+         
+         fntCache = fontResolver.font();
+         
+         int fontNum = fontResolver.resolveFontNum();
+         
+         config.font = fontNum;
+         
+         config.fontSize = fntCache.font.pointSize;
+         
+         config.fontName = fntCache.font.fontName;
+         
+         updateSize = true;
+      }
+      
+      if (init || updateSize || 
+          beforeUpdate.x != config.x ||
+          beforeUpdate.y != config.y || 
+          beforeUpdate.widthChars != config.widthChars ||
+          beforeUpdate.heightChars != config.heightChars ||
+          beforeUpdate.widthPixels != config.widthPixels
+          )
+      {
+         updateSize();
+         setSize(width(), height());
+         
+         setPhysicalLocation(config.x, config.y);
+         
+         dateTimeContent.updateSize(window(), fontResolver.resolveFontNum());
+         
+         if (config.upDown)
+         {
+            upButton.setEnabled(true);
+            upButton.setVisible(true);
+            downButton.setEnabled(true);
+            downButton.setVisible(true);
+         }
+         else
+         {
+            popupButton.setEnabled(true);
+            popupButton.setVisible(true);
+         }
+         
+         if (config.checkBox)
+         {
+            toggleButton.setEnabled(true);
+            toggleButton.setVisible(true);
+         }
+         
+         viewport.setSize(cc.dimensionFromNative(dateTimeContent.getVisibleDimension()));
+         
+         double h = viewport.height();
+         
+         if (config.checkBox)
+         {
+            toggleButton.config().heightChars = h;
+         }
+         
+         if (config.upDown)
+         {
+            upButton.config().clientHeightChars = h/2;
+            upButton.config().heightChars = h/2;
+            downButton.config().clientHeightChars = h/2;
+            downButton.config().heightChars = h/2;
+            buttonsPanel.setSize(upButton.width(), h);
+            Point center = upButton.getImgUp().location();
+            double imgHeight = upButton.getImgUp().height();
+            center.y = (h / 2 - imgHeight) /2;
+            upButton.getImgDown().setLocation(center);
+            upButton.getImgUp().setLocation(center);
+            upButton.getImgDisabled().setLocation(center);
+            center = downButton.getImgUp().location();
+            imgHeight = downButton.getImgUp().height();
+            center.y = (h / 2 - imgHeight) /2;
+            downButton.getImgDown().setLocation(center);
+            downButton.getImgUp().setLocation(center);
+            downButton.getImgDisabled().setLocation(center);
+         }
+         else
+         {
+            popupButton.config().clientHeightChars = h;
+            popupButton.config().heightChars = h;
+            buttonsPanel.setSize(popupButton.width(), h);
+            Point center = popupButton.getImgUp().location();
+            double imgHeight = popupButton.getImgUp().height();
+            center.y = (h - imgHeight) /2;
+            popupButton.getImgDown().setLocation(center);
+            popupButton.getImgUp().setLocation(center);
+            popupButton.getImgDisabled().setLocation(center);
+         }
+         
+         buttonsPanel.doLayout();
+         
+         doLayout();
+         
+         repaint = true;
+      }
+      
+      if (beforeUpdate.bodyBackgroundColor != config.bodyBackgroundColor ||
+          beforeUpdate.bodyForegroundColor != config.bodyForegroundColor ||
+          beforeUpdate.titleBackgroundColor != config.titleBackgroundColor ||
+          beforeUpdate.titleForegroundColor != config.titleForegroundColor ||
+          beforeUpdate.trailingForegroundColor != config.trailingForegroundColor)
+      {
+         if (config.bodyBackgroundColor != -1)
+         {
+            ColorRgb newColorBGR = new ColorRgb();
+            newColorBGR.setRgb(config.bodyBackgroundColor);
+            bodyColorResolver.sysBgColor = newColorBGR;
+         }
+         
+         if (config.bodyForegroundColor != -1)
+         {
+            ColorRgb newColorBGR = new ColorRgb();
+            newColorBGR.setRgb(config.bodyForegroundColor);
+            bodyColorResolver.sysFgColor = newColorBGR;
+         }
+         
+         if (config.titleBackgroundColor != -1)
+         {
+            ColorRgb newColorBGR = new ColorRgb();
+            newColorBGR.setRgb(config.titleBackgroundColor);
+            titleColorResolver.sysBgColor = newColorBGR;
+         }
+         
+         if (config.titleForegroundColor != -1)
+         {
+            ColorRgb newColorBGR = new ColorRgb();
+            newColorBGR.setRgb(config.titleForegroundColor);
+            titleColorResolver.sysFgColor = newColorBGR;
+         }
+         
+         if (config.trailingForegroundColor != -1)
+         {
+            ColorRgb newColorBGR = new ColorRgb();
+            newColorBGR.setRgb(config.trailingForegroundColor);
+            trailingColorResolver.sysFgColor = newColorBGR;
+         }
+         
+         repaint = true;
+      }
+      
+      if (init)
+      {
+         init = false;
+      }
+      if (repaint)
+      {
+         repaint();
+      }
+   }
+
+   /**
+    * Initializes the date and time widget.
+    * 
+    * @param    id
+    *           This widget id
+    * @param    cfg
+    *           This widget configuration
+    */
+   @Override
+   public void initialize(WidgetId id, CalendarConfig cfg)
+   {
+      config = ConfigManager.getInstance().resolveWidgetConfig(id, cfg);
+      ConfigManager.getInstance().replaceConfig(config, cfg);
+      setId(id);
+      locale = Locale.getDefault();
+      chrono = Chronology.ofLocale(locale);
+      
+      LocalDateTime initDateTime;
+      
+      if (config.dateTimeValue != null)
+      {
+         initDateTime = LocalDateTime.parse(config.dateTimeValue);
+      }
+      else
+      {
+         initDateTime = LocalDateTime.now();
+      }
+      
+      updateDateTimePattern(config.formatStyle, config.customFormat, initDateTime);
+      
+      // screen driver
+      if (gd == null)
+      {
+         gd = (GuiDriver) OutputManager.getDriver();
+      }
+      
+      // output manager
+      screen = screen();
+      cc = screen.coordinates();
+      
+      // font resolver
+      if (fontResolver == null)
+      {
+         fontResolver = new GuiFontResolver(WindowManager.resolveWindow(this), gd, config(), false);
+      }
+      
+      Theme theme = ThemeManager.getCurrentTheme();
+      
+      bodyColorResolver = new GuiColorResolver(gd,
+                                               config,
+                                               theme.getCalendarBodyBackgroundColor(),
+                                               theme.getCalendarBodyForegroundColor());
+      
+      titleColorResolver = new GuiColorResolver(gd,
+                                                config,
+                                                theme.getCalendarTitleBackgroundColor(),
+                                                theme.getCalendarTitleForegroundColor());
+      
+      trailingColorResolver = new GuiColorResolver(gd,
+                                                   config,
+                                                   theme.getCalendarTrailingBackgroundColor(),
+                                                   theme.getCalendarTrailingForegroundColor());
+      
+      bodyColorResolver.boxColor = gd.getSysColor(theme.getCalendarBodyForegroundColor());
+      
+      trailingColorResolver.selectionBgColor = gd.getSysColor(
+               theme.getSelectedDayBackgroundColor());
+      
+      trailingColorResolver.selectionFgColor = gd.getSysColor(
+               theme.getSelectedDayForegroundColor());
+      
+      widgetsFactory = screen.getFactory();
+      
+      if (config.checkBox)
+      {
+         WidgetId wid0 = WidgetId.nextID();
+         ToggleBoxConfig tgc = new ToggleBoxConfig();
+         tgc.id = wid0;
+         
+         toggleButton = new ToggleBoxGuiImpl(wid0, tgc);
+         toggleButton.initialize(wid0, tgc);
+         toggleButton.config().name = "toggleButton" + wid0.asInt();
+         toggleButton.config().enabled = true;
+         toggleButton.config().visible = true;
+         toggleButton.config().fixedWidth = true;
+         toggleButton.config().fixedHeight = true;
+         toggleButton.config().x = 0;
+         toggleButton.config().y = 0;
+         toggleButton.config().checked = true;
+         toggleButton.setColorResolver(bodyColorResolver);
+         
+         add(toggleButton);
+         
+         toggleButton.addKeyListener(new KeyListener()
+         {
+            
+            @Override
+            public void onKeyTyped(KeyInput event)
+            {
+               int key = event.actionCode();
+               
+               if (key == Keyboard.SE_VALUE_CHANGED)
+               {
+                  dateTimeContent.setEnabled(toggleButton.config().checked);
+               }
+            }
+            
+            @Override
+            public void onKeyPressed(KeyInput event)
+            {
+            }
+         });
+      }
+      
+      dateTimeContent = new DateTimeContent();
+      viewport = new Viewport<GuiOutputManager>(dateTimeContent);
+      add(viewport);
+      
+      buttonsPanel = new BorderedPanelGuiImpl();
+      
+      buttonsPanel.setId(WidgetId.nextID());
+      
+      Consumer<ButtonGuiImpl> Down = b -> ThemeManager.getCurrentTheme().setDownArrowImages(b);
+      
+      Consumer<ButtonGuiImpl> Up = b -> ThemeManager.getCurrentTheme().setUpArrowImages(b);
+
+      if (config.upDown)
+      {
+         upButton = createButton("upButton", BUTTON_SIZE, BUTTON_SIZE / 2, Up);
+         downButton = createButton("downButton", BUTTON_SIZE, BUTTON_SIZE / 2, Down);
+         buttonsPanel.setLayout(new StackLayout(Direction.VERTICAL));
+         buttonsPanel.add(upButton);
+         buttonsPanel.add(downButton);
+      }
+      else
+      {
+         popupButton = createButton("popupButton", BUTTON_SIZE, BUTTON_SIZE, Down);
+         buttonsPanel.setLayout(new BorderLayout<GuiOutputManager>());
+         buttonsPanel.add(popupButton);
+      }
+      
+      buttonsPanel.setColorResolver(bodyColorResolver);
+      
+      add(buttonsPanel);
+      
+      if (config.checkBox)
+      {
+         screen.getRegistry().addWidget(toggleButton);
+      }
+      
+      if (config.upDown)
+      {
+         screen.getRegistry().addWidget(upButton);
+         screen.getRegistry().addWidget(downButton);
+      }
+      else
+      {
+         screen.getRegistry().addWidget(popupButton);
+      }
+      
+      screen.getRegistry().addWidget(buttonsPanel);
+      
+      init = true;
+      
+      doLayout();
+      
+      buttonsPanel.doLayout();
+      
+      if (config.upDown)
+      {
+         upButton.addListener(new ActionListener()
+         {
+            @Override
+            public void onAction(ActionEvent event)
+            {
+               KeyInput keyInput = new KeyInput(CalendarGuiImpl.this,
+                                                EventType.KEY_PRESSED,
+                                                Keyboard.KA_CURSOR_UP);
+               processKeyEvent(keyInput);
+            }
+         });
+         downButton.addListener(new ActionListener()
+         {
+            
+            @Override
+            public void onAction(ActionEvent event)
+            {
+               KeyInput keyInput = new KeyInput(CalendarGuiImpl.this,
+                                                EventType.KEY_PRESSED,
+                                                Keyboard.KA_CURSOR_DOWN);
+                        processKeyEvent(keyInput);
+            }
+         });
+      }
+      else
+      {
+         popupButton.addListener(new ActionListener()
+         {
+            @Override
+            public void onAction(ActionEvent event)
+            {
+                  event.consume();
+                  popupIsActive = true;
+                  
+                  popupButton.setEnabled(false);
+                  
+                  if (config().checkBox)
+                  {
+                     // enable checkbox if it is disabled
+                     if (!toggleButton.config().checked)
+                     {
+                        toggleButton.config().checked = true;
+                        dateTimeContent.setEnabled(true);
+                     }
+                  }
+                  
+                  repaint();
+                  
+                  // force the driver to be in control, as this affects UI
+                  gd.setControl(true);
+
+                  CalendarPopup cal = new CalendarPopup();
+                  cal.setVisible(true);
+            }
+         });
+      }
+   }
+   
+   /**
+    * Handles the focus gained event.
+    * 
+    * @param    event
+    *           The focus event
+    */
+   @Override
+   public void onFocusGained(FocusEvent event)
+   {
+      repaint();
+   }
+   
+   /**
+    * Handles the focus lost event.
+    * 
+    * @param    event
+    *           The focus event
+    */
+   @Override
+   public void onFocusLost(FocusEvent event)
+   {
+      repaint();
+   }
+   
+   /**
+    * Sets the current focus to this widget itself.
+    */
+   @Override
+   public void firstFocus()
+   {
+      setFocusInt(this);
+   }
+
+   /**
+    * Returns true.
+    * 
+    * @return   True
+    */
+   @Override
+   public boolean focusTraversable()
+   {
+      return true;
+   }
+
+   /**
+    * Returns this widget itself.
+    * 
+    * @return   The widget itself
+    */
+   @Override
+   public Widget<GuiOutputManager> currentFocus()
+   {
+      return this;
+   }
+
+   /**
+    * Returns this widget itself.
+    * 
+    * @return   The widget itself
+    */
+   @Override
+   public Widget<GuiOutputManager> defaultFocus()
+   {
+      return this;
+   }
+
+   /**
+    * Tests if there is a focusable widget in this container except the given widget.
+    * 
+    * @param    exclude
+    *           The given widget
+    * 
+    * @return   True
+    */
+   @Override
+   public boolean hasFocusable(Widget<GuiOutputManager> exclude)
+   {
+      return true;
+   }
+
+   /**
+    * Update widget's size.
+    */
+   public void updateSize()
+   {
+      if (gd == null)
+      {
+         return;
+      }
+      
+      // The current widget window
+      Window<?> window = window();
+      
+      if (window == null)
+      {
+         // the widget is not attached, just return
+         return;
+      }
+      
+      CoordinatesConversion cc = screen().coordinates();
+      
+      // get font resolver
+      if (fontResolver == null)
+      {
+         fontResolver = new GuiFontResolver(window, gd, config(), false);
+      }
+      
+      int font = fontResolver.resolveFontNum();
+      
+      double inputHeight = config.heightChars > 0.0 && config.heightChars < 1.0
+                           ? config.heightChars : 1.0;
+      
+      config.clientHeightPixels = cc.heightToNative(inputHeight, window.getId(), font);
+      
+      if (config.widthChars != 0)
+      {
+         // the explicitly assigned width is the exact width of the widget,
+         // ignore format in this case.
+         // the width in this case is converted to physical size using
+         // the default font.
+         config.clientWidthChars = config.widthChars;
+         return;
+      }
+      
+      double charWidth = dateTimePattern.length();
+      
+      int pixelWidth = cc.widthToNative(charWidth, window.getId(), font) + BUTTON_SIZE;
+      
+      config.clientWidthPixels = pixelWidth;
+   }
+   
+   /**
+    * Update the date time pattern and date and time model.
+    * 
+    * @param    formatStyle
+    *           The calendar look and feel style
+    * @param    customPattern
+    *           The date and time pattern for date and time presentation
+    * @param    dateTime
+    *           The date and time to display
+    */
+   public void updateDateTimePattern(int formatStyle, String customPattern, LocalDateTime dateTime)
+   {
+      FormatStyle[] legacyStyles = CalendarConfig.toDateTimeStyles(formatStyle);
+      
+      if (CalendarConfig.isLocalizedFormat(formatStyle))
+      {
+         
+         dateTimePattern = DateTimeFormatterBuilder.getLocalizedDateTimePattern(
+                  legacyStyles[0], legacyStyles[1], chrono, locale);
+         // do consistent changes
+         config.customFormat = dateTimePattern;
+      }
+      else
+      {
+         //TODO: convert MS Date Time Picker format string to legacy date and time format string
+         dateTimePattern = customPattern;
+      }
+      
+      DateTimeFormatterBuilder builder = new DateTimeFormatterBuilder();
+      
+      builder.appendPattern(dateTimePattern);
+      
+      dateTimeFormatter = builder.toFormatter();
+      
+      java.util.Calendar c = java.util.Calendar.getInstance(locale);
+      
+      c.set(dateTime.getYear(), dateTime.getMonthValue() - 1, dateTime.getDayOfMonth(),
+               dateTime.getHour(), dateTime.getMinute(), dateTime.getSecond());
+      
+      fieldPositions = DateFormatFieldsAdapter.getDateTimeFieldPositions(dateTimePattern, c.getTime());
+      
+      displayedDateTime = dateTime;
+      
+      config.dateTimeValue = displayedDateTime.format(dateTimeFormatter);
+      
+      repaint();
+   }
+   
+   /**
+    * Gets the currently selected data and time field's index.
+    * 
+    * @return   The currently selected data and time field's index
+    */
+   public int getSelectedFieldIndex()
+   {
+      return Math.max(config.selectedFieldIndex, 0) % fieldPositions.length;
+   }
+   
+   /**
+    * Process key events that have been generated by this component.
+    * 
+    * @param    keyEvent
+    *           The key event to be handled.
+    */
+   @Override
+   public void processKeyEvent(KeyInput keyEvent)
+   {
+      if (!isEnabled())
+      {
+         return;
+      }
+      
+      if (hasFocus())
+      {
+         int key = keyEvent.actionCode();
+         
+         boolean respond = key == Keyboard.KA_CURSOR_LEFT || key == Keyboard.KA_CURSOR_RIGHT ||
+                           key == Keyboard.KA_CURSOR_UP || key == Keyboard.KA_CURSOR_DOWN ||
+                           key == Keyboard.KA_RETURN;
+         
+         if (key == Keyboard.KA_TAB || key == Keyboard.KA_BACK_TAB)
+         {
+            config.dateTimeValue = displayedDateTime.format(dateTimeFormatter);
+            if (key == Keyboard.KA_TAB)
+            {
+               ThinClient.nextTabStop(this);
+            }
+            else
+            {
+               ThinClient.previousTabStop(this);
+            }
+         }
+         
+         if (!respond)
+         {
+            return;
+         }
+         
+         int currentIndex = getSelectedFieldIndex();
+         
+         int upperLimit = fieldPositions.length - 1;
+         
+         if (key == Keyboard.KA_CURSOR_LEFT)
+         {
+            if (currentIndex == 0)
+            {
+               currentIndex = upperLimit;
+            }
+            else
+            {
+               currentIndex--;
+            }
+            
+            config.selectedFieldIndex = currentIndex;
+            
+            scrollLeftToTheCurrentField(currentIndex, upperLimit);
+         }
+         else if (key == Keyboard.KA_CURSOR_RIGHT)
+         {
+            if (currentIndex == upperLimit)
+            {
+               currentIndex = 0;
+            }
+            else
+            {
+               currentIndex++;
+            }
+            
+            config.selectedFieldIndex = currentIndex;
+            
+            scrollRightToTheCurrentField(currentIndex);
+         }
+         else if (key == Keyboard.KA_CURSOR_UP || key == Keyboard.KA_CURSOR_DOWN)
+         {
+            int dataField = fieldPositions[currentIndex].getField();
+            ChronoField modified = DateFormatFieldsAdapter.getChronoField(dataField);
+            
+            if (key == Keyboard.KA_CURSOR_UP)
+            {
+               displayedDateTime = displayedDateTime.plus(modified.getBaseUnit().getDuration());
+            }
+            else
+            {
+               displayedDateTime = displayedDateTime.minus(modified.getBaseUnit().getDuration());
+            }
+            
+            updateDateTimePattern(config.formatStyle, config.customFormat, displayedDateTime);
+            
+            config.dateTimeValue = displayedDateTime.format(dateTimeFormatter);
+         }
+         else if (key == Keyboard.KA_RETURN)
+         {
+            config.dateTimeValue = displayedDateTime.format(dateTimeFormatter);
+         }
+         
+         repaint();
+      }
+   }
+   
+   
+   
+   /**
+    * Selects a field under the mouse click pointer.
+    * 
+    * @param    event
+    *           The mouse event
+    */
+   @Override
+   public void mousePressed(MouseEvent event)
+   {
+      int targetX = event.getX();
+      
+      NativePoint widgetLoc = screenPhysicalLocation();
+      
+      targetX -= widgetLoc.x;
+      
+      if (config.checkBox)
+      {
+         targetX -= toggleButton.physicalDimension().width;
+      }
+      
+      String text = displayedDateTime.format(dateTimeFormatter);
+      NativePoint position = dateTimeContent.physicalLocation();
+      
+      for (int i = 0; i < fieldPositions.length; i++)
+      {
+         FieldPosition field = fieldPositions[i];
+         int visibleWidth = position.x + dateTimeContent.xOffset +
+                  getTextWidthNative(text.substring(0, field.getEndIndex()),
+                                     fontResolver.font().font);
+         if (visibleWidth > targetX)
+         {
+            config.selectedFieldIndex = i;
+            repaint();
+            break;
+         }
+      }
+      super.mouseClicked(event);
+   }
+   
+   /**
+    * Scrolls the date and time content right to the current highlighted field.
+    * 
+    * @param    currentIndex
+    *           The current index of the target field
+    */
+   private void scrollRightToTheCurrentField(int currentIndex)
+   {
+      FieldPosition field = fieldPositions[currentIndex];
+      String text = displayedDateTime.format(dateTimeFormatter);
+      
+      if (currentIndex == 0)
+      {
+         dateTimeContent.setPhysicalLocation(0, 0);
+      }
+      else
+      {
+         NativePoint position = dateTimeContent.physicalLocation();
+         int visibleWidth = position.x + dateTimeContent.xOffset +
+                  getTextWidthNative(text.substring(0, field.getEndIndex()),
+                                     fontResolver.font().font);
+         NativeDimension visiblePart = dateTimeContent.getVisibleDimension();
+         if (visibleWidth > visiblePart.width)
+         {
+            int scrollAmount = visibleWidth - visiblePart.width;
+            dateTimeContent.scroll(-scrollAmount, 0);
+         }
+      }
+   }
+   
+   /**
+    * Scrolls the date and time content left to the current highlighted field.
+    * 
+    * @param    currentIndex
+    *           The current index of the target field
+    * @param    upperLimit
+    *           The number of all date and time fields displayed by the date and time widget
+    */
+   private void scrollLeftToTheCurrentField(int currentIndex, int upperLimit)
+   {
+      String text = displayedDateTime.format(dateTimeFormatter);
+      
+      if (currentIndex == 0)
+      {
+         dateTimeContent.setPhysicalLocation(0, 0);
+      }
+      else
+      {
+         if (currentIndex != upperLimit)
+         {
+            NativePoint position = dateTimeContent.physicalLocation();
+            FieldPosition currField = fieldPositions[currentIndex];
+            int leftVisiblePartWidth = position.x + dateTimeContent.xOffset +
+                     getTextWidthNative(text.substring(0, currField.getBeginIndex()),
+                                        fontResolver.font().font);
+            if (leftVisiblePartWidth < 0)
+            {
+               dateTimeContent.scroll(-leftVisiblePartWidth, 0);
+            }
+         }
+         else
+         {
+            int scrollAmount = 0;
+            NativePoint position = dateTimeContent.physicalLocation();
+            NativeDimension visiblePart = dateTimeContent.getVisibleDimension();
+            for (int i = 1; i <= upperLimit; i++)
+            {
+               FieldPosition field = fieldPositions[i];
+               int visibleWidth = position.x + dateTimeContent.xOffset +
+                        getTextWidthNative(text.substring(0, field.getEndIndex()),
+                                           fontResolver.font().font);
+               if (visibleWidth > visiblePart.width)
+               {
+                  scrollAmount += getTextWidthNative(
+                           text.substring(field.getBeginIndex(), field.getEndIndex()),
+                           fontResolver.font().font);
+               }
+            }
+            dateTimeContent.scroll(-scrollAmount, 0);
+         }
+      }
+   }
+   
+   /**
+    * Determine the mouse actions processed by this widget.
+    * 
+    * @return   The mouse actions processed by this widget
+    */
+   @Override
+   protected int[] mouseActions()
+   {
+      return new int[]
+      {
+         MouseEvent.MOUSE_CLICKED, 
+         MouseEvent.MOUSE_PRESSED, 
+         MouseEvent.MOUSE_DRAGGED,
+         MouseEvent.MOUSE_ENTERED,
+         MouseEvent.MOUSE_EXITED,
+         MouseEvt.MOUSE_HOVERABLE
+      };
+   }
+   
+   /**
+    * Represents the calendar popup that helps to select a date via a calendar sheet using
+    * mouse or keyboard keys.
+    */
+   public class CalendarPopup
+   extends BorderedPanelGuiImpl
+   {
+      /** Calendar header panel with buttons and month and year title */
+      private BorderedPanelGuiImpl calendarHeaderPanel;
+      
+      /** The button to select the previous month that is the month before the selected one*/
+      private ButtonGuiImpl previousMonthButton;
+      
+      /** Calendar title */
+      private TextCell calendarTitle;
+      
+      /** Title panel with calendar title */
+      private BorderedPanelGuiImpl titlePanel;
+      
+      /** The button to select the next month that is the month after the selected one*/
+      private ButtonGuiImpl nextMonthButton;
+      
+      /** The days of week header panel */
+      private BorderedPanelGuiImpl weekHeadersPanel;
+      
+      /** The calendar model */
+      private CalendarMonthModel model;
+      
+      /** The calendar days panel */
+      private BorderedPanelGuiImpl daysInMonthPanel;
+      
+      /** The calendar current date panel */
+      private BorderedPanelGuiImpl currentDatePanel;
+      
+      /** The calendar owner window */
+      private OverlayWindow ownerWindow;
+      
+      /**
+       * Calculates the size of this widget in character units.
+       * 
+       * @return   The size of this widget in character units
+       */
+      @Override
+      public Dimension dimension()
+      {
+         return new Dimension(width(), height());
+      }
+      
+      /**
+       * Calculates the available area.
+       * 
+       * @param    size
+       *           The given size
+       * 
+       * @return   The size of the available area.
+       */
+      private Dimension getAvailableSize(Dimension size)
+      {
+         double width = size.width;
+         double height = size.height;
+         
+         Insets padding = insets();
+         
+         if (padding != null)
+         {
+            width -= padding.widthDelta();
+            height -= padding.heightDelta();
+         }
+         
+         if (border != null)
+         {
+            padding = border.insets();
+            
+            if (padding != null)
+            {
+               width -= padding.widthDelta();
+               height -= padding.heightDelta();
+            }
+         }
+         
+         return new Dimension(width, height);
+      }
+      
+      /**
+       * Returns the height of this widget.
+       * 
+       * @return   The widget's height in character units.
+       */
+      @Override
+      public double height()
+      {
+         FontCache fc = fontResolver.font();
+         
+         String titleText = model.getMonthAndYear();
+         
+         int titleHeight = getTextHeightNative(titleText, fc.font);
+         
+         int pixHeight= ROWS_NUMBER * titleHeight + ROWS_NUMBER * 2 * VERTICAL_ROW_MARGIN;
+         
+         return cc.heightFromNative(pixHeight);
+      }
+      
+      /**
+       * Returns the width of this widget.
+       * 
+       * @return   The widget's width in character units.
+       */
+      @Override
+      public double width()
+      {
+         FontCache fc = fontResolver.font();
+         
+         String titleText = model.getMonthAndYear();
+         
+         int titleWidth = getTextWidthNative(titleText, fc.font);
+         
+         int pixWidth = titleWidth + 2 * BUTTON_SIZE + 2 * 2 * BUTTON_MARGIN;
+         
+         List<String> days = model.getDaysOfWeek();
+         
+         int daysWidth = COLUMNS_NUMBER * 2 * HORIZONTAL_CELL_MARGIN;
+         
+         for(String day : days)
+         {
+            daysWidth += getTextWidthNative(day, fc.font);
+         };
+         
+         if (daysWidth > pixWidth)
+         {
+            pixWidth = daysWidth;
+         }
+         
+         return cc.widthFromNative(pixWidth);
+      }
+      
+      /**
+       * Show widget.
+       */
+      @Override
+      public void show()
+      {
+         previousMonthButton.setEnabled(true);
+         nextMonthButton.setEnabled(true);
+         
+         _setVisible(true);
+         topLevelWindow().show();
+      }
+      
+      /**
+       * Hide this widget and remove it.
+       */
+      @Override
+      public void hide()
+      {
+         if (!isVisible())
+         {
+            return;
+         }
+         topLevelWindow().close();
+         super.hide();
+         popupIsActive = false;
+         popupButton.setEnabled(true);
+         
+         ThinClient.getInstance().independentEventDrawingBracket(
+                  CalendarGuiImpl.this,
+                  () -> CalendarGuiImpl.this.repaint());
+      }
+
+      /**
+       * Creates the calendar panel with calendar header control panel with two buttons, the days
+       * of week static panel, the days of month control panel to select the date and the current
+       * date panel at the bottom to display the today date.
+       */
+      public CalendarPopup()
+      {
+         super(new StackLayout<GuiOutputManager>(Direction.VERTICAL), new LineBorderGuiImpl());
+         setId(WidgetId.nextID());
+         setParent(CalendarGuiImpl.this);
+         
+         model = new CalendarMonthModel(displayedDateTime.toLocalDate());
+         
+         Dimension size = dimension();
+         
+         setSize(size);
+         
+         Dimension reducedSize = getAvailableSize(size);
+         
+         double contentWidth = reducedSize.width;
+         double contentHeight = reducedSize.height;
+
+         calendarHeaderPanel = new BorderedPanelGuiImpl();
+         calendarHeaderPanel.setLayout(new StackLayout<GuiOutputManager>(Direction.HORIZONTAL));
+         calendarHeaderPanel.setId(WidgetId.nextID());
+         calendarHeaderPanel.setColorResolver(titleColorResolver);
+         Consumer<ButtonGuiImpl> Left = b -> ThemeManager.getCurrentTheme().setLeftArrowImages(b);
+         
+         previousMonthButton = createButton("prevMonthButton", BUTTON_SIZE, BUTTON_SIZE, Left);
+         
+         BorderedPanelGuiImpl leftPanel = new BorderedPanelGuiImpl();
+         leftPanel.setLayout(new BorderLayout<GuiOutputManager>());
+         leftPanel.setColorResolver(titleColorResolver);
+         leftPanel.add(previousMonthButton);
+         calendarHeaderPanel.add(leftPanel);
+
+         
+         Consumer<ButtonGuiImpl> Right = b -> ThemeManager.getCurrentTheme().setRightArrowImages(b);
+         
+         nextMonthButton = createButton("nextMonthButton", BUTTON_SIZE, BUTTON_SIZE, Right);
+         
+         double titleWidth = contentWidth - previousMonthButton.width() - nextMonthButton.width();
+         double rowHeight = contentHeight / 9;
+         double cellWidth = contentWidth / 7;
+         double titleHeight = contentHeight / 6;
+         double cellHeight = 11 * contentHeight / 108;
+         
+         titlePanel = new BorderedPanelGuiImpl();
+         titlePanel.setLayout(new BorderLayout());
+         titlePanel.setId(WidgetId.nextID());
+         titlePanel.setColorResolver(titleColorResolver);
+         calendarTitle = new TextCell(titleWidth, rowHeight, model.getMonthAndYear(),
+                  VerticalAlignment.CENTER);
+         calendarTitle.preferredFgColor = titleColorResolver.fgColor;
+         calendarTitle.preferredBgColor = titleColorResolver.bgColor;
+         titlePanel.add(calendarTitle);
+         calendarHeaderPanel.add(titlePanel);
+
+         BorderedPanelGuiImpl rightPanel = new BorderedPanelGuiImpl();
+         rightPanel.setLayout(new BorderLayout<GuiOutputManager>());
+         rightPanel.setColorResolver(titleColorResolver);
+         rightPanel.add(nextMonthButton);
+         calendarHeaderPanel.add(rightPanel);
+
+         add(calendarHeaderPanel);
+         
+         weekHeadersPanel = new BorderedPanelGuiImpl();
+         weekHeadersPanel.setLayout(new GridLayout(7, 1));
+         weekHeadersPanel.setId(WidgetId.nextID());
+         weekHeadersPanel.setColorResolver(bodyColorResolver);
+         
+         weekHeadersPanel.setSize(contentWidth, rowHeight);
+         
+         List<String> days = model.getDaysOfWeek();
+         
+         days.forEach((day)->
+         {
+            TextCell dayTitle = new TextCell(cellWidth, rowHeight, day, VerticalAlignment.CENTER);
+            weekHeadersPanel.add(dayTitle);
+         });
+         
+         add(weekHeadersPanel);
+         
+         daysInMonthPanel = new BorderedPanelGuiImpl();
+         daysInMonthPanel.setLayout(new GridLayout(7, 6));
+         daysInMonthPanel.setId(WidgetId.nextID());
+         
+         LocalDate sftd = model.startFirstTrailingDay;
+         LocalDate eftd = model.endFirstTrailingDay;
+         
+         if (sftd != null && eftd != null)
+         {
+            setContinuosPeriodOfDays(sftd, eftd, cellWidth, cellHeight,
+                     trailingColorResolver.bgColor, trailingColorResolver.fgColor);
+         }
+         
+         LocalDate smd = model.startMonthDay;
+         LocalDate emd = model.endMonthDay;
+         
+         if (smd != null && emd != null)
+         {
+            setContinuosPeriodOfDays(smd, emd, cellWidth, cellHeight, null, null);
+         }
+         
+         LocalDate sltd = model.startLastTrailingDay;
+         LocalDate eltd = model.endLastTrailingDay;
+         
+         if (sltd != null && eltd != null)
+         {
+            setContinuosPeriodOfDays(sltd, eltd, cellWidth, cellHeight,
+                     trailingColorResolver.bgColor, trailingColorResolver.fgColor);
+         }
+
+         add(daysInMonthPanel);
+         
+         screen.getRegistry().addWidget(this);
+         screen.getRegistry().addWidget(daysInMonthPanel);
+         currentDatePanel = new BorderedPanelGuiImpl();
+         currentDatePanel.setLayout(new GridLayout(1, 1));
+         currentDatePanel.setId(WidgetId.nextID());
+         
+         TextCell today = new TextCell(contentWidth, rowHeight, model.getToday());
+         currentDatePanel.add(today);
+         
+         add(currentDatePanel);
+         
+         nextMonthButton.addListener(new ActionListener()
+         {
+            
+            @Override
+            public void onAction(ActionEvent event)
+            {
+               event.consume();
+               model.selectNextMonth();
+               updateCalendarView();
+            }
+         });
+         
+         previousMonthButton.addListener(new ActionListener()
+         {
+            
+            @Override
+            public void onAction(ActionEvent event)
+            {
+               event.consume();
+               model.selectPreviousMonth();
+               updateCalendarView();
+            }
+         });
+         
+         leftPanel.setSize(previousMonthButton.width(), titleHeight);
+         leftPanel.doLayout();
+         
+         titlePanel.setSize(contentWidth - previousMonthButton.width() - nextMonthButton.width(),
+                            titleHeight);
+         titlePanel.doLayout();
+         
+         rightPanel.setSize(nextMonthButton.width(), titleHeight);
+         rightPanel.doLayout();
+         
+         calendarHeaderPanel.setSize(contentWidth, titleHeight);
+         calendarHeaderPanel.doLayout();
+         weekHeadersPanel.setSize(contentWidth, rowHeight);
+         weekHeadersPanel.doLayout();
+         daysInMonthPanel.setSize(contentWidth, 11 * contentHeight / 18);
+         daysInMonthPanel.doLayout();
+         currentDatePanel.setSize(contentWidth, rowHeight);
+         currentDatePanel.doLayout();
+         doLayout();
+
+         ownerWindow = new OverlayWindow(this, CalendarGuiImpl.this.topLevelWindow())
+         {
+            /**
+             * This overlay window returns its calendar popup as its unique focused widget.
+             * 
+             * @return   This calendar popup
+             */
+            @Override
+            public Widget<GuiOutputManager> currentFocus()
+            {
+               return CalendarPopup.this;
+            }
+
+            /**
+             * This overlay window returns its calendar popup as its unique focused widget.
+             * 
+             * @param    recurse
+             *           The boolean flag
+             * 
+             * @return   This calendar popup
+             */
+            @Override
+            public Widget<GuiOutputManager> currentFocus(boolean recurse)
+            {
+               return CalendarPopup.this;
+            }
+         };
+         
+         ownerWindow.setDestroyingListener(()->
+         {
+            CalendarPopup.this.hide();
+         });
+         
+         NativePoint np = UiUtils.getDropDownPhysicalLocation(CalendarGuiImpl.this, this, gd);
+         
+         setPhysicalLocation(np.x, np.y);
+         
+         ownerWindow.setLocation(screenLocation());
+         
+         topLevelWindow().setSize(width(), height());
+         
+         parent().setFocus(this);
+      }
+      
+      /**
+       * Sets up the continuous calendar area given by its days period, its cell's size and 
+       * the preferred foreground and background colors.
+       * 
+       * @param    start
+       *           The first day of the given period
+       * @param    end
+       *           The last day of the given period
+       * @param    cellWidth
+       *           The cell's width in character units
+       * @param    cellHeight
+       *           The cell's height in character units
+       * @param    prefBgColor
+       *           The preferred background color
+       * @param    prefFgColor
+       *           The preferred foreground color
+       */
+      private void setContinuosPeriodOfDays(LocalDate start,
+                                            LocalDate end,
+                                            double cellWidth,
+                                            double cellHeight,
+                                            ColorRgb prefBgColor,
+                                            ColorRgb prefFgColor)
+      {
+         int firstTrailing = start.get(ChronoField.DAY_OF_MONTH);
+         int endTrailing = end.get(ChronoField.DAY_OF_MONTH);
+         
+         int selected;
+         
+         if (model.selected.isAfter(start) && model.selected.isBefore(end) ||
+             (model.selected.equals(start) || model.selected.equals(end)))
+         {
+            selected = model.selected.get(ChronoField.DAY_OF_MONTH);
+         }
+         else
+         {
+            selected = -1;
+         }
+         
+         for (int i = firstTrailing; i <= endTrailing; i++)
+         {
+            TextCell dayInMonth = new TextCell(cellWidth, cellHeight, String.valueOf(i));
+            
+            if (i == selected)
+            {
+               dayInMonth.selected = true;
+            }
+            
+            if (prefBgColor != null)
+            {
+               dayInMonth.preferredBgColor = prefBgColor;
+            }
+            
+            if (prefFgColor != null)
+            {
+               dayInMonth.preferredFgColor = prefFgColor;
+            }
+            
+            daysInMonthPanel.add(dayInMonth);
+         }
+      }
+      
+      /**
+       * Updates the calendar content according to the calendar model.
+       */
+      private void updateDaysInMonth()
+      {
+         int widgetsNumber = daysInMonthPanel.widgets().length; // 42
+         
+         LocalDate firstDay = model.getFirstVisibleDate();
+         
+         for(int i = 0; i < widgetsNumber; i++)
+         {
+            Widget<?> widget = daysInMonthPanel.get(i);
+            if (widget instanceof TextCell)
+            {
+               LocalDate currDay = firstDay.plusDays(i);
+               int day = currDay.get(ChronoField.DAY_OF_MONTH);
+               ((TextCell) widget).text = String.valueOf(day);
+               if (currDay.equals(model.selected))
+               {
+                  ((TextCell) widget).selected = true;
+               }
+               else
+               {
+                  ((TextCell) widget).selected = false;
+               }
+               
+               if ((model.startFirstTrailingDay != null &&
+                        (model.startFirstTrailingDay.equals(currDay) ||
+                         (model.startFirstTrailingDay.isBefore(currDay) &&
+                          model.endFirstTrailingDay.isAfter(currDay)) ||
+                          model.endFirstTrailingDay.equals(currDay)))      ||
+                   (model.startLastTrailingDay != null &&
+                          (model.startLastTrailingDay.equals(currDay) ||
+                           (model.startLastTrailingDay.isBefore(currDay) &&
+                            model.endLastTrailingDay.isAfter(currDay)) ||
+                            model.endLastTrailingDay.equals(currDay))))
+               {
+                  ((TextCell) widget).preferredBgColor = trailingColorResolver.bgColor;
+                  ((TextCell) widget).preferredFgColor = trailingColorResolver.fgColor;
+               }
+               else
+               {
+                  ((TextCell) widget).preferredBgColor = null;
+                  ((TextCell) widget).preferredFgColor = null;
+               }
+            }
+         };
+      }
+      
+      /**
+       * Calculates the location of the calendar popup relative to the parent window.
+       * 
+       * @return   The location of the calendar popup relative to the parent window
+       */
+      @Override
+      public Point screenLocation()
+      {
+         if (parent() == null) {
+            throw new IllegalStateException("widget is not in the container");
+         }
+         
+         return Coordinate.scale(parent().screenLocation().translate(location()));
+      }
+      
+      /**
+       * Determine the mouse actions processed by this widget.
+       * 
+       * @return   The mouse actions processed by this widget
+       */
+      @Override
+      protected int[] mouseActions()
+      {
+         return new int[]
+         {
+                  MouseEvent.MOUSE_CLICKED, 
+                  MouseEvent.MOUSE_PRESSED, 
+                  MouseEvent.MOUSE_DRAGGED,
+                  MouseEvent.MOUSE_ENTERED,
+                  MouseEvent.MOUSE_EXITED,
+                  MouseEvt.MOUSE_HOVERABLE
+         };
+      }
+
+      /**
+       * Handles the date selection.
+       * 
+       * @param    event
+       *           The mouse event
+       */
+      @Override
+      public void mouseClicked(MouseEvent event)
+      {
+         NativePoint mousePoint = new NativePoint(event.getX(), event.getY());
+         
+         NativeRectangle area = daysInMonthPanel.physicalBounds();
+         
+         if (area.contains(mousePoint))
+         {
+            int col = Math.round((event.getX() - area.left()) * 7 / area.width());
+            int row = Math.round((event.getY() - area.top()) * 6 / area.height());
+            
+            // The number of days passed from the day in the first row and the first column of
+            // this calendar
+            int days = col + row * 7; 
+            
+            LocalDate firstDayInCalendar = model.getFirstVisibleDate();
+            
+            model.set(firstDayInCalendar.plusDays(days));
+            
+            updateDisplayedDateTimeValue();
+         }
+         
+      }
+
+      /**
+       * Overwrites the standard findMouseSource in order to delegate mouse clicks to this
+       * parent widget. 
+       * 
+       * @param    point
+       *           The physical point within this container
+       * 
+       * @return   The widget that handles this event
+       */
+      @Override
+      public Widget<GuiOutputManager> findMouseSource(NativePoint point)
+      {
+         Widget<GuiOutputManager> source = super.findMouseSource(point);
+         
+         if (source == previousMonthButton || source == nextMonthButton)
+         {
+            return source;
+         }
+         
+         return this;
+      }
+      
+      /**
+       * Updates the displayed date/time value according to the calendar model changes.
+       */
+      private void updateDisplayedDateTimeValue()
+      {
+         displayedDateTime = LocalDateTime.of(model.selected, LocalTime.of(0, 0, 0, 0));
+         
+         updateDateTimePattern(config.formatStyle, config.customFormat, displayedDateTime);
+         
+         config.dateTimeValue = displayedDateTime.format(dateTimeFormatter);
+         
+         hide();
+         
+         repaint();
+      }
+      
+      /**
+       * Updates the calendar view according to the changed calendar model.
+       */
+      private void updateCalendarView()
+      {
+         calendarTitle.text = model.getMonthAndYear();
+         updateDaysInMonth();
+         repaint();
+      }
+      
+      /**
+       * Handles UP, DOWN, LEFT and RIGHT keys.
+       * 
+       * @param    event
+       *           The key input event
+       */
+      private void handleKeyEvent(KeyInput event)
+      {
+         int key = event.actionCode();
+         
+         if (key == Keyboard.KA_RETURN)
+         {
+            updateDisplayedDateTimeValue();
+         }
+         
+         boolean respond = key == Keyboard.KA_CURSOR_LEFT || key == Keyboard.KA_CURSOR_RIGHT ||
+                           key == Keyboard.KA_CURSOR_UP || key == Keyboard.KA_CURSOR_DOWN;
+         
+         if (!respond)
+         {
+            return;
+         }
+         
+         if (key == Keyboard.KA_CURSOR_LEFT)
+         {
+            model.selectPreviousDay();
+         }
+         else if (key == Keyboard.KA_CURSOR_RIGHT)
+         {
+            model.selectNextDay();
+         }
+         else if (key == Keyboard.KA_CURSOR_DOWN)
+         {
+            model.selectNextWeekDay();
+         }
+         else if (key == Keyboard.KA_CURSOR_UP)
+         {
+            model.selectPreviousWeekDay();
+         }
+         
+         updateCalendarView();
+      }
+      
+      /**
+       * Returns the widget that has the current focus.
+       * 
+       * @return   The calendar popup widget
+       */
+      @Override
+      public Widget<GuiOutputManager> currentFocus()
+      {
+         return this;
+      }
+
+      /**
+       * Returns the widget that has the current focus by default.
+       * 
+       * @return   The calendar popup widget
+       */
+      @Override
+      public Widget<GuiOutputManager> defaultFocus()
+      {
+         return this;
+      }
+
+      /**
+       * Handles UP, DOWN, LEFT and RIGHT keys.
+       * 
+       * @param    event
+       *           The key input event
+       */
+      @Override
+      public void processKeyEvent(KeyInput event)
+      {
+         handleKeyEvent(event);
+      }
+   }
+   
+   /**
+    * Represents the model for the calendar popup.
+    */
+   public class CalendarMonthModel
+   {
+      /**
+       * The beginning day of the trailing days before the current calendar month
+       */
+      private LocalDate startFirstTrailingDay;
+      
+      /**
+       * The end day of the trailing days before the current calendar month
+       */
+      private LocalDate endFirstTrailingDay;
+      
+      /**
+       * The current calendar month represented by [1..12]
+       */
+      private int month;
+      
+      /**
+       * The current calendar year
+       */
+      private int year;
+      
+      /**
+       * The beginning day of the current calendar month
+       */
+      private LocalDate startMonthDay;
+      
+      /**
+       * The last day of the current calendar month
+       */
+      private LocalDate endMonthDay;
+      
+      /**
+       * The beginning day of the trailing days after the current calendar month
+       */
+      private LocalDate startLastTrailingDay;
+      
+      /**
+       * The end day of the trailing days after the current calendar month
+       */
+      private LocalDate endLastTrailingDay;
+      
+      /**
+       * The selected day of the current calendar month
+       */
+      private LocalDate selected;
+      
+      /**
+       * The special formatter for the calendar title
+       */
+      private final DateTimeFormatter monthYearFormatter;
+      
+      /**
+       * The special formatter for the calendar footer
+       */
+      private final DateTimeFormatter todayFormatter;
+      
+      /**
+       * The list of days of a week
+       */
+      private final ArrayList<String> daysOfWeek;
+      
+      /**
+       * Represents the month model for the calendar popup.
+       * 
+       * @param    selected
+       *           The given date
+       */
+      public CalendarMonthModel(LocalDate selected)
+      {
+         DateTimeFormatterBuilder builder = new DateTimeFormatterBuilder();
+         
+         builder.appendPattern("MMMM  YYYY");
+         
+         monthYearFormatter = builder.toFormatter();
+         
+         DateTimeFormatterBuilder builder2 = new DateTimeFormatterBuilder();
+         
+         builder2.appendPattern(DateTimeFormatterBuilder.getLocalizedDateTimePattern(
+                  FormatStyle.MEDIUM, null, chrono, locale));
+         
+         todayFormatter = builder2.toFormatter();
+         
+         set(selected);
+         
+         daysOfWeek = new ArrayList<String>();
+         
+         daysOfWeek.add(DayOfWeek.of(7).getDisplayName(TextStyle.SHORT, locale));
+
+         for (int d = 1; d <= 6; d++)
+         {
+            daysOfWeek.add(DayOfWeek.of(d).getDisplayName(TextStyle.SHORT, locale));
+         }
+      }
+      
+      /**
+       * Updates the current month model for the calendar popup with the given date.
+       * 
+       * @param    selected
+       *           The given date
+       */
+      private void set(LocalDate selected)
+      {
+         this.selected = selected;
+
+         this.month = selected.get(ChronoField.MONTH_OF_YEAR);
+         this.year = selected.get(ChronoField.YEAR);
+         
+         YearMonth currentMonth = YearMonth.of(year, month);
+         startMonthDay = currentMonth.atDay(1);
+         endMonthDay   = currentMonth.atEndOfMonth();
+         
+         int firstTrailingDays = startMonthDay.get(ChronoField.DAY_OF_WEEK) % 7;
+         
+         if (firstTrailingDays > 0)
+         {
+            startFirstTrailingDay = startMonthDay.minusDays(firstTrailingDays);
+            endFirstTrailingDay = startMonthDay.minusDays(1);
+         }
+         else
+         {
+            startFirstTrailingDay = null;
+            endFirstTrailingDay = null;
+         }
+         
+         LocalDate endDayInView;
+         
+         if (startFirstTrailingDay != null)
+         {
+            endDayInView = startFirstTrailingDay.plusDays(41);
+         }
+         else
+         {
+            endDayInView = startMonthDay.plusDays(41);
+         }
+         
+         if (endMonthDay.isBefore(endDayInView))
+         {
+            
+            startLastTrailingDay = endMonthDay.plusDays(1);
+            endLastTrailingDay = endDayInView;
+         }
+         else
+         {
+            startLastTrailingDay = null;
+            endLastTrailingDay = null;
+         }
+      }
+      
+      /**
+       * Sets the following day after the selected date to be a new selected one and updates
+       * this model.
+       * 
+       * @return   This model instance
+       */
+      public CalendarMonthModel selectNextDay()
+      {
+         set(selected.plusDays(1));
+         return this;
+      }
+      
+      /**
+       * Sets the previous day before the selected date to be a new selected one and updates
+       * this model.
+       * 
+       * @return   This model instance
+       */
+      public CalendarMonthModel selectPreviousDay()
+      {
+         set(selected.minusDays(1));
+         return this;
+      }
+      
+      /**
+       * Sets the day of the following week after the selected date to be a new selected one and
+       * updates this model.
+       * 
+       * @return   This model instance
+       */
+      public CalendarMonthModel selectNextWeekDay()
+      {
+         set(selected.plusWeeks(1));
+         return this;
+      }
+      
+      /**
+       * Sets the day of the previous week before the selected date to be a new selected one and
+       * updates this model.
+       * 
+       * @return   This model instance
+       */
+      public CalendarMonthModel selectPreviousWeekDay()
+      {
+         set(selected.minusWeeks(1));
+         return this;
+      }
+      
+      /**
+       * Sets the day of the following month after the selected date to be a new selected one and
+       * updates this model.
+       * 
+       * @return   This model instance
+       */
+      public CalendarMonthModel selectNextMonth()
+      {
+         set(selected.plusMonths(1));
+         return this;
+      }
+      
+      /**
+       * Sets the day of the previous month before the selected date to be a new selected one and
+       * updates this model.
+       * 
+       * @return   This model instance
+       */
+      public CalendarMonthModel selectPreviousMonth()
+      {
+         set(selected.minusMonths(1));
+         return this;
+      }
+      
+      /**
+       * Gets the current calendar month and year as a title for this calendar.
+       * 
+       * @return   The current calendar month and year as a title for this calendar
+       */
+      public String getMonthAndYear()
+      {
+         return selected.format(monthYearFormatter);
+      }
+      
+      /**
+       * Gets the list of days of a week.
+       * 
+       * @return   The list of days of a week
+       */
+      public List<String> getDaysOfWeek()
+      {
+         return daysOfWeek;
+      }
+      
+      /**
+       * Gets the today date formatted according to the today formatter style.
+       * 
+       * @return   The today date
+       */
+      public String getToday()
+      {
+         return LocalDate.now().format(todayFormatter);
+      }
+      
+      /**
+       * Returns the date of the day beginning this calendar.
+       * 
+       * @return   The date of the day beginning this calendar
+       */
+      public LocalDate getFirstVisibleDate()
+      {
+         if (startFirstTrailingDay != null)
+         {
+            return startFirstTrailingDay;
+         }
+         
+         return startMonthDay;
+      }
+   }
+   
+   /**
+    * Defines vertical alignment enumeration type.
+    */
+   public enum VerticalAlignment
+   {
+      /** The top alignment */
+      TOP,
+      /** The center alignment */
+      CENTER,
+      /** The bottom alignment */
+      BOTTOM
+   }
+   
+   /**
+    * Represents a simple text cell. 
+    */
+   public class TextCell
+   extends AbstractWidget<GuiOutputManager>
+   {
+      /** Represents the cell's width given in character units */
+      private double widthInChars;
+      
+      /** Represents the cell's height given in character units */
+      private double heightInChars;
+      
+      /**
+       * The given displayed text
+       */
+      private String text;
+      
+      /**
+       * The given vertical alignment of the displayed text within this cell. The default text
+       * position is at the cell bottom.
+       */
+      private VerticalAlignment verticalAlignment;
+      
+      /**
+       * Indicates that this text cell is selected or not.
+       */
+      private boolean selected;
+      
+      /**
+       * The preferred background color
+       */
+      private ColorRgb preferredBgColor;
+      
+      /**
+       * The preferred foreground color
+       */
+      private ColorRgb preferredFgColor;
+      
+      /**
+       * Creates this text cell using the given size in character units and displaying the given
+       * text at the bottom.
+       * 
+       * @param    widthInChars
+       *           The given width in character units
+       * @param    heightInChars
+       *           The given height in character units
+       * @param    text
+       *           The given text
+       */
+      public TextCell(double widthInChars, double heightInChars, String text)
+      {
+         this(widthInChars, heightInChars, text, VerticalAlignment.BOTTOM);
+      }
+      
+      /**
+       * Creates this text cell using the given size in character units and displaying the given
+       * text according its vertical alignment.
+       * 
+       * @param    widthInChars
+       *           The given width in character units
+       * @param    heightInChars
+       *           The given height in character units
+       * @param    text
+       *           The given text
+       * @param    verticalAlignment
+       *           The given vertical alignment
+       */
+      public TextCell(double widthInChars,
+                      double heightInChars,
+                      String text,
+                      VerticalAlignment verticalAlignment)
+      {
+         this.widthInChars = widthInChars;
+         this.heightInChars = heightInChars;
+         this.text = text;
+         this.verticalAlignment = verticalAlignment;
+      }
+      
+      /**
+       * Calculates the size of this widget in character units.
+       * 
+       * @return   The size of this widget in character units
+       */
+      @Override
+      public Dimension dimension()
+      {
+         return new Dimension(width(), height());
+      }
+      
+      /**
+       * Implements the main method for drawing this widget.
+       */
+      @Override
+      public void draw()
+      {
+         NativePoint p = physicalLocation();
+         NativeDimension d = this.physicalDimension();
+         
+         // resolve font
+         final FontCache fntCache = fontResolver.font();
+         
+         int fontNum = fontResolver.resolveFontNum();
+         
+         int fontHeight = FontManager.getFontHeight(window(), fntCache.font, fontNum, gd);
+         
+         // set up clipping rectangle
+         NativeRectangle clip = clipRectangle(p, d);
+         
+         gd.draw(getId(), p, clip, () ->
+         {
+            gd.setGuiFont(fntCache.font);
+            
+            ColorRgb bgColor;
+            ColorRgb fgColor;
+            
+            if (selected)
+            {
+               bgColor = trailingColorResolver.selectionBgColor;
+               fgColor = trailingColorResolver.selectionFgColor;
+            }
+            else
+            {
+               if (preferredBgColor != null)
+               {
+                  bgColor = preferredBgColor;
+               }
+               else
+               {
+                  bgColor = bodyColorResolver.bgColor;
+               }
+               
+               if (preferredFgColor != null)
+               {
+                  fgColor = preferredFgColor;
+               }
+               else
+               {
+                  fgColor = bodyColorResolver.fgColor;
+               }
+            }
+            // this offset is used with drawStringWithinBox
+            // to make the target text be placed at the center,
+            // or the top, or bottom of this cell
+            int yOffset = calculateYOffset(d.height, fontHeight);
+            
+            // clear the area
+            gd.setColor(bgColor);
+            gd.fillRect(0, 0, d.width, d.height);
+            gd.setColor(fgColor);
+            gd.drawStringWithinBox(0, yOffset, d.width, d.height, text, null, true);
+         });
+      }
+      
+      /**
+       * Calculates the vertical offset of this text cell. The calculated offset is used with
+       * GuiDriver.drawStringWithinBox to make the target text be placed at the center,
+       * or the top, or bottom of this cell.
+       * 
+       * @param    cellHeight
+       *           The cell height
+       * @param    fontHeight
+       *           The font height
+       * 
+       * @return   The vertical offset of this text cell
+       */
+      private int calculateYOffset(int cellHeight, int fontHeight)
+      {
+         int yOffset = cellHeight;
+         
+         switch(verticalAlignment)
+         {
+            case TOP:
+               yOffset -= (3 * fontHeight / 4);
+               break;
+            case CENTER:
+               yOffset -= (5 * fontHeight / 8);
+               break;
+            default:
+               // alignment to the bottom side of this text cell
+               yOffset -= (fontHeight / 2);
+         }
+         
+         return yOffset;
+      }
+      
+      /**
+       * Returns the height of this widget.
+       * 
+       * @return   The widget's height in character units.
+       */
+      @Override
+      public double height()
+      {
+         return heightInChars;
+      }
+
+      /**
+       * Returns the minimum size of this cell text.
+       * 
+       * @return   The minimum size of this cell text
+       */
+      @Override
+      public Dimension minimumSize()
+      {
+         return dimension();
+      }
+      
+      /**
+       * Returns the width of this widget.
+       * 
+       * @return   The widget's width in character units.
+       */
+      @Override
+      public double width()
+      {
+         return widthInChars;
+      }
+      
+      /**
+       * Sets the new size of this text cell.
+       * 
+       * @param    width
+       *           The new width
+       * @param    height
+       *           The new height
+       */
+      public void setSize(double width, double height)
+      {
+         this.widthInChars = width;
+         this.heightInChars = height;
+         
+         repaint();
+      }
+   }
+   /**
+    * Represents a scrollable widget and control displaying and modifying the date/time content
+    * with help of keyboard keys. Buttons LEFT and RIGHT are used to navigate to the target
+    * component (field) of the displayed date/time and buttons UP and DOWN are used
+    * to modify the currently selected date/time component(field).
+    */
+   public class DateTimeContent
+   extends AbstractWidget<GuiOutputManager>
+   implements ScrollableWidget<GuiOutputManager>
+   {
+      /** The width of this widget given in pixel units */
+      private int widthInPixels;
+      
+      /** The height of this widget given in pixel units */
+      private int heightInPixels;
+      
+      /** The horizontal offset of the date/time content from the left side */
+      private int xOffset;
+      
+      /**
+       * Updates the size of this widget according to the given font.
+       * 
+       * @param    window
+       *           The owner of this widget
+       * @param    font
+       *           The given font
+       */
+      public void updateSize(Window window, int font)
+      {
+         WidgetId parentId = window.getId();
+         
+         double len = dateTimePattern.length();
+         String text = displayedDateTime.format(dateTimeFormatter);
+         int patternWidthInPixels = getTextWidthNative(text, fontResolver.font().font);
+         
+         widthInPixels = Math.max(cc.widthToNative(len, parentId, font), patternWidthInPixels) +
+                         BUTTON_SIZE;
+         
+         double inputHeight = config.heightChars > 0.0 && config.heightChars < 1.0
+                  ? config.heightChars : 1.0;
+
+         heightInPixels = cc.heightToNative(inputHeight, parentId, font);
+      }
+      
+      /**
+       * Calculates the scroll size of this widget given in pixel units.
+       * 
+       * @return   The scroll size of this widget given in pixel units 
+       */
+      @Override
+      public NativeDimension getScrollDimension()
+      {
+         NativeDimension vd = getVisibleDimension();
+         if (vd.width >= widthInPixels)
+         {
+            widthInPixels = vd.width;
+         }
+         if (vd.height >= heightInPixels)
+         {
+            heightInPixels = vd.height;
+         }
+         return new NativeDimension(widthInPixels, heightInPixels);
+      }
+      
+      /**
+       * Returns the visible size of this widget in pixel units.
+       * 
+       * @return   The visible size of this widget given in pixel units
+       */
+      @Override
+      public NativeDimension getVisibleDimension()
+      {
+         return cc.dimensionToNative(dimension());
+      }
+      
+      /**
+       * Returns the minimum scroll step.
+       * 
+       * @return   The minimum scroll step given in pixel units
+       */
+      @Override
+      public NativeDimension getScrollStep()
+      {
+         return new NativeDimension(1, 1);
+      }
+      
+      /**
+       * Scrolls the widget's content according to the given physical translation.
+       * 
+       * @param    newXPosition
+       *           The given translation along a horizontal in pixel units
+       * @param    newYPosition
+       *           The given translation along a vertical in pixel units
+       */
+      @Override
+      public void scroll(Integer newXPosition, Integer newYPosition)
+      {
+         NativePoint p = physicalLocation();
+         p.translate(newXPosition, newYPosition);
+         setPhysicalLocation(p.x, p.y);
+         repaint();
+      }
+      
+      /**
+       * Tests if this widget supports a scroll popup. This implementation always returns false.
+       * 
+       * @return   false
+       */
+      @Override
+      public boolean isScrollPopupSupported()
+      {
+         return false;
+      }
+      
+      /**
+       * Calculates the size of this widget in character units.
+       * 
+       * @return   The size of this widget in character units
+       */
+      @Override
+      public Dimension dimension()
+      {
+         Dimension dim = CalendarGuiImpl.this.dimension();
+         
+         Insets insets = CalendarGuiImpl.this.insets();
+         
+         if (insets != null)
+         {
+            dim = dim.reducedBy(insets);
+         }
+         
+         if (CalendarGuiImpl.this.border != null)
+         {
+            CalendarGuiImpl.this.border.insets();
+            
+            if (insets != null)
+            {
+               dim = dim.reducedBy(insets);
+            }
+         }
+         
+         insets = buttonsPanel.insets(); // doesn't have a border
+         
+         if (insets != null)
+         {
+            dim = dim.reducedBy(insets);
+         }
+         
+         double leftPadding;
+         
+         if (config.checkBox)
+         {
+            leftPadding = toggleButton.width();
+         }
+         else
+         {
+            leftPadding = 0;
+         }
+         
+         return dim.reducedBy(new Insets(0, leftPadding, 0, buttonsPanel.width()));
+      }
+      
+      /**
+       * Implements the main method for drawing this widget.
+       */
+      @Override
+      public void draw()
+      {
+         // get location and size
+         Viewport parent = parent(Viewport.class);
+         NativePoint p = parent.physicalLocation();
+         NativePoint delta = physicalLocation();
+         NativePoint p1 = p.offset(delta.x, 0);
+         NativeDimension d = this.physicalDimension();
+         Theme theme = ThemeManager.getCurrentTheme();
+         
+         // refresh widget settings
+         
+         // determine colors to use
+         bodyColorResolver.colors();
+         trailingColorResolver.colors();
+         titleColorResolver.colors();
+         
+         // resolve font
+         final FontCache fntCache = fontResolver.font();
+         
+         int fontNum = fontResolver.resolveFontNum();
+         
+         int fontHeight = FontManager.getFontHeight(window(), fntCache.font, fontNum, gd);
+         
+         xOffset = is3DBorder() ? 1 : 0;
+         
+         // set up clipping rectangle
+         NativeRectangle clip = clipRectangle(p, d);
+         
+         gd.draw(getId(), p, clip, () ->
+         {
+            // clear the area
+            gd.setColor(bodyColorResolver.bgColor);
+            gd.fillRect(0, 0, d.width, d.height);
+         });
+         
+         // clippable drawing start 
+         NativeRectangle clip1 = clipRectangle(p1, getScrollDimension());
+         gd.draw(getId(), p1, clip1, () ->
+         {
+            // clear the area
+            gd.setColor(bodyColorResolver.bgColor);
+            gd.fillRect(0, 0, d.width, d.height);
+            
+            gd.setGuiFont(fntCache.font);
+            
+            int y = d.height;
+            
+            String text = displayedDateTime.format(dateTimeFormatter);
+            
+            TextLookAndFeel textLookAndFeel;
+            
+            if (isEnabled())
+            {
+               //enabled look and feel
+               textLookAndFeel = theme.getTextLookAndFeel(bodyColorResolver,
+                                                          trailingColorResolver);
+            }
+            else
+            {
+               //disabled look and feel
+               textLookAndFeel = theme.getTextLookAndFeel(trailingColorResolver,
+                                                          trailingColorResolver);
+            }
+            
+            boolean select = CalendarGuiImpl.this.hasFocus() &&
+                             !CalendarGuiImpl.this.popupIsActive &&
+                             isEnabled();
+            
+            TextLineSelection selection = getFieldSelection(text, select);
+            
+            // calculates the y offset to use with drawTextSelection such
+            // that the target text is displayed vertically centered
+            if (textLookAndFeel.getTextBaseline() == TextBaseline.MIDDLE)
+            {
+               y -= 7 * fontHeight / 8;
+            }
+            else
+            {
+               y -= 11 * fontHeight / 8;
+            }
+            
+            gd.drawTextSelection(selection, textLookAndFeel, xOffset, y, fontHeight, 0);
+         });
+      }
+      
+      /**
+       * Returns the height of this widget.
+       * 
+       * @return   The widget's height in character units.
+       */
+      @Override
+      public double height()
+      {
+         return dimension().height;
+      }
+      
+      /**
+       * Returns the minimum size of this widget.
+       * 
+       * @return   The minimum size of this widget
+       */
+      @Override
+      public Dimension minimumSize()
+      {
+         return dimension();
+      }
+
+      /**
+       * Returns the width of this widget.
+       * 
+       * @return   The widget's width in character units.
+       */
+      @Override
+      public double width()
+      {
+         return dimension().width;
+      }
+
+      /**
+       * Gets the field selection for the given displayed date and time value.
+       * 
+       * @param    txt
+       *           The displayed date and time value
+       * @param    select
+       *           The flag indicating that the current field must be selected or not.
+       * 
+       * @return   The field selection
+       */
+      public TextLineSelection getFieldSelection(String txt, boolean select)
+      {
+         int txtLen = txt.length();
+         
+         int start;
+         
+         int end;
+         
+         if (select)
+         {
+            int selectedFieldIndex = getSelectedFieldIndex(); // selected field
+            
+            start = fieldPositions[selectedFieldIndex].getBeginIndex();
+            
+            end = fieldPositions[selectedFieldIndex].getEndIndex();
+         }
+         else
+         {
+            start = txtLen;
+            
+            end = txtLen;
+         }
+         
+         String[] texts = new String[3];
+         
+         // prefix not-selected text
+         texts[0] = (start == 0 ? "" : txt.substring(0, start));
+         // selected text
+         texts[1] = txt.substring(start, end);
+         // suffix not-selected text
+         texts[2] = (end == txtLen ? "" : txt.substring(end));
+
+         int[] hintWidths = new int[3];
+         
+         for(int i = 0; i < 3; i++)
+         {
+            if (texts[i].isEmpty())
+            {
+               hintWidths[i] = 0;
+            }
+            else
+            {
+               hintWidths[i] = getTextWidthNative(texts[i], fontResolver.font().font);
+            }
+         }
+         
+         /**
+          * Defines the current text selection object.
+          */
+         return new TextLineSelection()
+         {
+            /**
+             * Returns the 3-tuple of string widths used as hint widths for this line split into outer
+             * and selected text.
+             * 
+             * @return   The 3-tuple of string hint widths in pixels
+             */
+            @Override
+            public int[] getTextWidthsHint()
+            {
+               return hintWidths;
+            }
+            
+            /**
+             * Returns the column and row, where the current text selection gets the its origin.
+             * 
+             * @return   The beginning of the current text selection
+             */
+            @Override
+            public NativePoint getSelectionStart()
+            {
+               return new NativePoint(start, 0);
+            }
+
+            /**
+             * Returns the most closest point, column and row, that breaks the continuous selection text
+             * part.
+             * 
+             * @return   The break point, column and row, of the current text selection
+             */
+            @Override
+            public NativePoint getSelectionEnd()
+            {
+               return new NativePoint(end, 0);
+            }
+            
+            /**
+             * Returns the 3-tuple of text parts into which this line has been split by text selection.
+             * 
+             * @return   The 3-tuple of text parts
+             */
+            @Override
+            public String[] getLineParts()
+            {
+               return texts;
+            }
+         };
+      }
+   }
+   
+   /**
+    * Gets the current screen value formatted according its format style.
+    * 
+    * @return   The current screen value as a character
+    */
+   @Override
+   public BaseDataType getValue()
+   {
+      return new character(config.dateTimeValue);
+   }
+   
+   /**
+    * Sets the new selected date value.
+    * 
+    * @param    value
+    *           The new selected date value
+    */
+   @Override
+   public void setValue(BaseDataType value)
+   {
+      //TODO
+   }
+   
+   /**
+    * Gets the current screen value formatted according its format style.
+    * 
+    * @return   The current screen value as a character
+    */
+   @Override
+   public String getText()
+   {
+      return config.dateTimeValue;
+   }
+   
+   /**
+    * Tests if this widget has new settings.
+    * 
+    * @return   True if this widget has new settings, otherwise false.
+    */
+   @Override
+   public boolean isModified()
+   {
+      return config.modified;
+   }
+}

